# -*- coding: utf-8 -*-

import numpy as np
import cv2
from pathlib import Path
from keras.models import load_model


input_dir = Path.cwd() / r'PATH'               # image path
files_FT = list(input_dir.rglob("*.png"))      # image type
model = load_model('MODEL')                    # model path


X_img,predictions,predictions_word = [],[],[]

# read images into X_img like grayscale
for path in files_FT:
    img = cv2.imread(str(path),0)
    X_img.append(img)
X_img = np.array(X_img)


# prediction
predictions_percent = model.predict(X_img)

for i in predictions_percent:
    predictions.append(i.argmax())
    
for i in range(len(predictions)):
    if predictions[i] == 0:
        predictions_word.append('ball')
    if predictions[i] == 1:
        predictions_word.append('cage')
    if predictions[i] == 2:
        predictions_word.append('norm')
    if predictions[i] == 3:
        predictions_word.append('outer')
