# -*- coding: utf-8 -*-

from sklearn.metrics import confusion_matrix
from sklearn.ensemble import RandomForestClassifier
from sklearn.neighbors import KNeighborsClassifier
from sklearn.model_selection import train_test_split
from sklearn.preprocessing import StandardScaler
from sklearn.svm import SVC
from joblib import load
import csv


X = []

# read predictors from file into X
radek = []
with open('PATH', 'r') as file:         # predictors file path
    reader = csv.reader(file, delimiter = ' ')
    for row in reader:
        for i in row:
            radek.append(float(i))
        X.append(radek)
        radek = []
 

# preprocessing - standardization
scaler = StandardScaler()
scaler.fit(X)
X = scaler.transform(X)

# read models
svc_model = load('SVC_model2.joblib')
knn_model = load('KNN_model2.joblib')
# rfc_model = load('RFC_model2.joblib')


# SVC method
svc_predictions = svc_model.predict(X)

# KNN method
knn_predictions = knn_model.predict(X)

# # RFC method
# rfc_predictions = rfc_model.predict(X)



