# -*- coding: utf-8 -*-
from sklearn.metrics import confusion_matrix
from sklearn.ensemble import RandomForestClassifier
from sklearn.neighbors import KNeighborsClassifier
from sklearn.model_selection import train_test_split
from sklearn.preprocessing import StandardScaler
from sklearn.svm import SVC
import csv


X,y = [],[]

# read target values from file into y
with open('PATH', 'r') as file:                    # targe values file path
    reader = csv.reader(file,delimiter = '\n')
    for row in reader:
        y.append(str(row[0]))


# read predictors from file into X
radek = []
with open('PATH', 'r') as file:                    # predictors file path
    reader = csv.reader(file, delimiter = ' ')
    for row in reader:
        for i in row:
            radek.append(float(i))
        X.append(radek)
        radek = []

 
# train and test split
X_train, X_test, y_train, y_test = train_test_split(X,y,test_size=0.25)  

# preprocessing - standardization
scaler = StandardScaler()
scaler.fit(X_train)
X_train = scaler.transform(X_train)
X_test = scaler.transform(X_test)

# # parameter tunning
# from sklearn.model_selection import GridSearchCV
# par_clf = GridSearchCV(KNeighborsClassifier(), {'n_neighbors':[1,2,3,4,5,6,7,8,9,10,15,20],'weights':['uniform','distance'],'algorithm':['auto','ball_tree','kd_tree','brute']},cv=5)
# par_clf.fit(X_train, y_train)
# print('Best score: ',par_clf.best_score_)
# print('Best parameters: ',par_clf.best_params_)


# SVM method
model = SVC(decision_function_shape='ovo',kernel='rbf',C=200,gamma='auto')
model.fit(X_train, y_train)
svm_pred = model.predict(X_test)
print("SVC model score: ", model.score(X_test, y_test))
print("SVC model confusion matrix: \n",confusion_matrix(y_test, svm_pred))


# KNN method
knn = KNeighborsClassifier(n_neighbors=4,algorithm='auto',weights='distance')
knn_model = knn.fit(X_train, y_train)
knn_pred = knn_model.predict(X_test)
print("KNN model score: ",knn_model.score(X_test,y_test))
print("KNN model confusion matrix: \n",confusion_matrix(y_test, knn_pred))

# RF method
rf = RandomForestClassifier(n_estimators=500,criterion='gini')
rf_model = rf.fit(X_train, y_train)
rf_pred = rf_model.predict(X_test)
print("RFC model score: ",rf_model.score(X_test,y_test))
print("RFC model confusion matrix: \n",confusion_matrix(y_test, rf_pred))

